namespace IRaCIS.Core.Domain.Models;

[Comment("影像 - 非dicom检查")]
[Table("NoneDicomStudy")]
public class NoneDicomStudy : BaseFullDeleteAuditEntity
{
    #region 导航属性
    [JsonIgnore]
    public List<NoneDicomStudyFile> NoneDicomFileList { get; set; }

    [JsonIgnore]
    public List<NoneDicomStudyFile> TaskNoneDicomFileList { get; set; }

    [JsonIgnore]
    public SubjectVisit SubjectVisit { get; set; }
    [JsonIgnore]
    public Subject Subject { get; set; }

    #endregion
    public string StudyCode { get; set; } = string.Empty;

    /// <summary>
    /// 检查名称
    /// </summary>
    public string StudyName { get; set; } = string.Empty;

    public int FileCount { get; set; }

    public int Code { get; set; }

    public Guid TrialId { get; set; }
    public Guid SubjectId { get; set; }
    public Guid SubjectVisitId { get; set; }
    public string BodyPart { get; set; } = string.Empty;
    public string Modality { get; set; } = string.Empty;

    public DateTime ImageDate { get; set; }
    public string Description { get; set; } = string.Empty;


    public bool IsReading { get; set; } = true;

    #region Video 暂时无用

    public string VideoName { get; set; } = string.Empty;

    public string VideoObjectName { get; set; } = string.Empty;

    public DateTime? UploadVideoTime { get; set; }

    public string VideoUrl { get; set; } = string.Empty;

    #endregion


}

