﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class TrialNormal : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "ReviewerFileType",
                table: "TrialNormalRecord");

            migrationBuilder.AlterColumn<Guid>(
                name: "TrialFileRecordId",
                table: "TrialNormalRecord",
                type: "uniqueidentifier",
                nullable: true,
                comment: "关联具体的文件记录，记录里面有大小，格式，名称",
                oldClrType: typeof(Guid),
                oldType: "uniqueidentifier",
                oldComment: "关联具体的文件记录，记录里面有大小，格式，名称");

            migrationBuilder.AddColumn<Guid>(
                name: "HistoryFileId",
                table: "TrialNormalRecord",
                type: "uniqueidentifier",
                nullable: true,
                comment: "历史文件");

            migrationBuilder.CreateIndex(
                name: "IX_TrialNormalRecord_HistoryFileId",
                table: "TrialNormalRecord",
                column: "HistoryFileId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialNormalRecord_TrialFileRecordId",
                table: "TrialNormalRecord",
                column: "TrialFileRecordId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialFile_TrialFileTypeId",
                table: "TrialFile",
                column: "TrialFileTypeId");

            migrationBuilder.AddForeignKey(
                name: "FK_TrialFile_TrialFileType_TrialFileTypeId",
                table: "TrialFile",
                column: "TrialFileTypeId",
                principalTable: "TrialFileType",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TrialNormalRecord_TrialFile_HistoryFileId",
                table: "TrialNormalRecord",
                column: "HistoryFileId",
                principalTable: "TrialFile",
                principalColumn: "Id");

            migrationBuilder.AddForeignKey(
                name: "FK_TrialNormalRecord_TrialFile_TrialFileRecordId",
                table: "TrialNormalRecord",
                column: "TrialFileRecordId",
                principalTable: "TrialFile",
                principalColumn: "Id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_TrialFile_TrialFileType_TrialFileTypeId",
                table: "TrialFile");

            migrationBuilder.DropForeignKey(
                name: "FK_TrialNormalRecord_TrialFile_HistoryFileId",
                table: "TrialNormalRecord");

            migrationBuilder.DropForeignKey(
                name: "FK_TrialNormalRecord_TrialFile_TrialFileRecordId",
                table: "TrialNormalRecord");

            migrationBuilder.DropIndex(
                name: "IX_TrialNormalRecord_HistoryFileId",
                table: "TrialNormalRecord");

            migrationBuilder.DropIndex(
                name: "IX_TrialNormalRecord_TrialFileRecordId",
                table: "TrialNormalRecord");

            migrationBuilder.DropIndex(
                name: "IX_TrialFile_TrialFileTypeId",
                table: "TrialFile");

            migrationBuilder.DropColumn(
                name: "HistoryFileId",
                table: "TrialNormalRecord");

            migrationBuilder.AlterColumn<Guid>(
                name: "TrialFileRecordId",
                table: "TrialNormalRecord",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"),
                comment: "关联具体的文件记录，记录里面有大小，格式，名称",
                oldClrType: typeof(Guid),
                oldType: "uniqueidentifier",
                oldNullable: true,
                oldComment: "关联具体的文件记录，记录里面有大小，格式，名称");

            migrationBuilder.AddColumn<int>(
                name: "ReviewerFileType",
                table: "TrialNormalRecord",
                type: "int",
                nullable: true,
                comment: "文件类型，阅片人中使用");
        }
    }
}
