﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class TrianingRecord : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AlterColumn<Guid>(
                name: "TrialFileRecordId",
                table: "TrialTrianingRecord",
                type: "uniqueidentifier",
                nullable: true,
                comment: "关联具体的文件记录，记录里面有大小，格式，名称",
                oldClrType: typeof(Guid),
                oldType: "uniqueidentifier",
                oldComment: "关联具体的文件记录，记录里面有大小，格式，名称");

            migrationBuilder.AddColumn<Guid>(
                name: "HistoryFileRecordId",
                table: "TrialTrianingRecord",
                type: "uniqueidentifier",
                nullable: true,
                comment: "历史文件");

            migrationBuilder.CreateIndex(
                name: "IX_TrialTrianingRecord_HistoryFileRecordId",
                table: "TrialTrianingRecord",
                column: "HistoryFileRecordId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialTrianingRecord_TrialFileRecordId",
                table: "TrialTrianingRecord",
                column: "TrialFileRecordId");

            migrationBuilder.AddForeignKey(
                name: "FK_TrialTrianingRecord_TrialFile_HistoryFileRecordId",
                table: "TrialTrianingRecord",
                column: "HistoryFileRecordId",
                principalTable: "TrialFile",
                principalColumn: "Id");

            migrationBuilder.AddForeignKey(
                name: "FK_TrialTrianingRecord_TrialFile_TrialFileRecordId",
                table: "TrialTrianingRecord",
                column: "TrialFileRecordId",
                principalTable: "TrialFile",
                principalColumn: "Id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_TrialTrianingRecord_TrialFile_HistoryFileRecordId",
                table: "TrialTrianingRecord");

            migrationBuilder.DropForeignKey(
                name: "FK_TrialTrianingRecord_TrialFile_TrialFileRecordId",
                table: "TrialTrianingRecord");

            migrationBuilder.DropIndex(
                name: "IX_TrialTrianingRecord_HistoryFileRecordId",
                table: "TrialTrianingRecord");

            migrationBuilder.DropIndex(
                name: "IX_TrialTrianingRecord_TrialFileRecordId",
                table: "TrialTrianingRecord");

            migrationBuilder.DropColumn(
                name: "HistoryFileRecordId",
                table: "TrialTrianingRecord");

            migrationBuilder.AlterColumn<Guid>(
                name: "TrialFileRecordId",
                table: "TrialTrianingRecord",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"),
                comment: "关联具体的文件记录，记录里面有大小，格式，名称",
                oldClrType: typeof(Guid),
                oldType: "uniqueidentifier",
                oldNullable: true,
                oldComment: "关联具体的文件记录，记录里面有大小，格式，名称");
        }
    }
}
